FIX: Exclude softwire func tests from execution
[csit.git] / bootstrap-vpp-verify-weekly.sh
1 #!/bin/bash
2 # Copyright (c) 2016 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -x
16
17 cat /etc/hostname
18 cat /etc/hosts
19
20 VIRL_SERVERS=("10.30.51.28" "10.30.51.29" "10.30.51.30")
21 VIRL_SERVER=""
22
23 VIRL_USERNAME=jenkins-in
24 VIRL_PKEY=priv_key
25 VIRL_SERVER_STATUS_FILE="status"
26 VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
27 VIRL_SESSION_EXPIRY="620"
28
29 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
30 export PYTHONPATH=${SCRIPT_DIR}
31
32 # Create tmp dir
33 mkdir ${SCRIPT_DIR}/tmp
34
35 # Use tmp dir to store log files
36 LOG_PATH="${SCRIPT_DIR}/tmp"
37
38 OS_ID=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g')
39 OS_VERSION_ID=$(grep '^VERSION_ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g')
40
41 if [ "$OS_ID" == "centos" ]; then
42     DISTRO="CENTOS"
43     PACKAGE="rpm"
44     sudo yum install -y python-devel python-virtualenv
45 elif [ "$OS_ID" == "ubuntu" ]; then
46     DISTRO="UBUNTU"
47     PACKAGE="deb"
48     export DEBIAN_FRONTEND=noninteractive
49     sudo apt-get -y update
50     sudo apt-get -y install libpython2.7-dev python-virtualenv
51 else
52     echo "$OS_ID is not yet supported."
53     exit 1
54 fi
55
56 # Temporarily download VPP packages from nexus.fd.io
57 if [ "${#}" -ne "0" ]; then
58     arr=(${@})
59     echo ${arr[0]}
60 else
61     # Download the specific VPP build install packages
62     VPP_VERSION=$(< ${SCRIPT_DIR}/VPP_STABLE_VER_${DISTRO})
63     CSIT_DIR=${SCRIPT_DIR}
64     source "${SCRIPT_DIR}/resources/libraries/bash/function/artifacts.sh"
65     download_artifacts
66     # Need to revert -euo as the rest of script is not optimized for this.
67     set +euo pipefail
68 fi
69
70 VIRL_DIR_LOC="/tmp/"
71 VPP_PKGS=(vpp*.$PACKAGE)
72 VPP_PKGS_FULL=("${VPP_PKGS[@]/#/${VIRL_DIR_LOC}}")
73 echo ${VPP_PKGS[@]}
74
75 VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_${DISTRO})
76 VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_${DISTRO})
77
78 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
79
80 function ssh_do() {
81     echo
82     echo "### "  ssh $@
83     ssh ${SSH_OPTIONS} $@
84 }
85
86 rm -f ${VIRL_PKEY}
87 cat > ${VIRL_PKEY} <<EOF
88 -----BEGIN RSA PRIVATE KEY-----
89 MIIEpQIBAAKCAQEA+IHXq87GcqMR1C47rzx6Cbip5Ghq8pKrbqKrP5Nf41HcYrT6
90 GOXl9nFWKsMOzIlIn+8y7Il27eZh7csQGApbg8QLiHMtcYEmWNzKZpkqg4nuAPxX
91 VXwlKgnKX902SrET9Gp9TDayiHtCRWVfrlPPPSA0UEXW6BjLN/uHJ+W/Xzrrab+9
92 asBVa05vT2W6n0KJ66zfCaeDM912mQ6SttscAwFoWDmdHlegiVqrlIG2ABxOvxxz
93 L3dM3iSmlmQlzv9bThjo+nI4KFYh6m5wrZmAo5r/4q9CIJc21HVnTqkGOWJIZz6J
94 73lePJVSq5gYqaoGw3swFEA/MDkOx7baWKSoLQIDAQABAoIBAQCNBeolNp+JWJ76
95 gQ4fwLsknyXSV6sxYyhkDW4PEwwcTU06uqce0AAzXVffxne0fMe48x47+zqBgPbb
96 4huM+Pu8B9nfojUMr5TaYtl9Zbgpk3F8H7dT7LKOa6XrxvZTZrADSRc30+Z26zPN
97 e9zTaf42Gvt0/l0Zs1BHwbaOXqO+XuwJ3/F9Sf3PQYWXD3EOWjpHDP/X/1vAs6lV
98 SLkm6J/9KKE1m6I6LTYjIXuYt4SXybW6N2TSy54hhQtYcDUnIU2hR/PHVWKrGA0J
99 kELgrtTNTdbML27O5gFWU4PLUEYTZ9fN11D6qUZKxLcPOiPPHXkiILMRCCnG5DYI
100 ksBAU/YlAoGBAPxZO9VO18TYc8THV1nLKcvT2+1oSs1UcA2wNQMU55t910ZYinRa
101 MRwUhMOf8Mv5wOeiZaRICQB1PnVWtDVmGECgPpK6jUxqAwn8rgJcnoafLGL5YKMY
102 RVafTe6N5LXgCaOcJrk21wxs6v7ninEbUxxc575urOvZMBkymDw91dwbAoGBAPwa
103 YRhKhrzFKZzdK0RadVjnxKvolUllpoqqg3XuvmeAJHAOAnaOgVWq68NAcp5FZJv0
104 2D2Up7TX8pjf9MofP1SJbcraKBpK4NzfNkA0dSdEi+FhVofAJ9umB2o5LW1n7sab
105 UIrjsdzSJK/9Zb9yTTHPyibYzNEgaJV1HsbxfEFXAoGAYO2RmvRm0phll18OQVJV
106 IpKk9kLKAKZ/R/K32hAsikBC8SVPQTPniyaifFWx81diblalff2hX4ipTf7Yx24I
107 wMIMZuW7Im/R7QMef4+94G3Bad7p7JuE/qnAEHJ2OBnu+eYfxaK35XDsrq6XMazS
108 NqHE7hOq3giVfgg+C12hCKMCgYEAtu9dbYcG5owbehxzfRI2/OCRsjz/t1bv1seM
109 xVMND4XI6xb/apBWAZgZpIFrqrWoIBM3ptfsKipZe91ngBPUnL9s0Dolx452RVAj
110 yctHB8uRxWYgqDkjsxtzXf1HnZBBkBS8CUzYj+hdfuddoeKLaY3invXLCiV+PpXS
111 U4KAK9kCgYEAtSv0m5+Fg74BbAiFB6kCh11FYkW94YI6B/E2D/uVTD5dJhyEUFgZ
112 cWsudXjMki8734WSpMBqBp/J8wG3C9ZS6IpQD+U7UXA+roB7Qr+j4TqtWfM+87Rh
113 maOpG56uAyR0w5Z9BhwzA3VakibVk9KwDgZ29WtKFzuATLFnOtCS46E=
114 -----END RSA PRIVATE KEY-----
115 EOF
116 chmod 600 ${VIRL_PKEY}
117
118 #
119 # Pick a random host from the array of VIRL servers, and attempt
120 # to reach it and verify it's status.
121 #
122 # The server must be reachable, and have a "status" file with
123 # the content "PRODUCTION", to be selected.
124 #
125 # If the server is not reachable, or does not have the correct
126 # status, remove it from the array and start again.
127 #
128 # Abort if there are no more servers left in the array.
129 #
130 while [[ ! "$VIRL_SERVER" ]]
131 do
132     num_hosts=${#VIRL_SERVERS[@]}
133     if [ $num_hosts == 0 ]
134     then
135         echo "No more VIRL candidate hosts available, failing."
136         exit 127
137     fi
138     element=$[ $RANDOM % $num_hosts ]
139     virl_server_candidate=${VIRL_SERVERS[$element]}
140     virl_server_status=$(ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${virl_server_candidate} cat $VIRL_SERVER_STATUS_FILE 2>&1)
141     echo VIRL HOST $virl_server_candidate status is \"$virl_server_status\"
142     if [ "$virl_server_status" == "$VIRL_SERVER_EXPECTED_STATUS" ]
143     then
144         # Candidate is in good status. Select this server.
145         VIRL_SERVER="$virl_server_candidate"
146     else
147         # Candidate is in bad status. Remove from array.
148         VIRL_SERVERS=("${VIRL_SERVERS[@]:0:$element}" "${VIRL_SERVERS[@]:$[$element+1]}")
149     fi
150 done
151
152 # Copy the files to VIRL host
153 scp ${SSH_OPTIONS} ${VPP_PKGS[@]} \
154     ${VIRL_USERNAME}@${VIRL_SERVER}:${VIRL_DIR_LOC}
155
156 result=$?
157 if [ "${result}" -ne "0" ]; then
158     echo "Failed to copy vpp deb files to virl host"
159     echo ${result}
160     exit ${result}
161 fi
162
163 # Start a simulation on VIRL server
164 echo "Starting simulation on VIRL server"
165
166 function stop_virl_simulation {
167     ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVER}\
168         "stop-testcase ${VIRL_SID}"
169 }
170
171 VIRL_SID=$(ssh ${SSH_OPTIONS} \
172     ${VIRL_USERNAME}@${VIRL_SERVER} \
173     "start-testcase -vv --copy ${VIRL_TOPOLOGY} \
174     --expiry ${VIRL_SESSION_EXPIRY} \
175     --release ${VIRL_RELEASE} ${VPP_PKGS_FULL[@]}")
176 retval=$?
177 if [ ${retval} -ne "0" ]; then
178     echo "VIRL simulation start failed"
179     exit ${retval}
180 fi
181
182 if [[ ! "${VIRL_SID}" =~ session-[a-zA-Z0-9_]{6} ]]; then
183     echo "No VIRL session ID reported."
184     exit 127
185 fi
186
187 # Upon script exit, cleanup the simulation execution
188 trap stop_virl_simulation EXIT
189 echo ${VIRL_SID}
190
191 ssh_do ${VIRL_USERNAME}@${VIRL_SERVER} cat /scratch/${VIRL_SID}/topology.yaml
192
193 # Download the topology file from virl session
194 scp ${SSH_OPTIONS} \
195     ${VIRL_USERNAME}@${VIRL_SERVER}:/scratch/${VIRL_SID}/topology.yaml \
196     topologies/enabled/topology.yaml
197
198 retval=$?
199 if [ ${retval} -ne "0" ]; then
200     echo "Failed to copy topology file from VIRL simulation"
201     exit ${retval}
202 fi
203
204
205 virtualenv --system-site-packages env
206 . env/bin/activate
207
208 echo pip install
209 pip install -r ${SCRIPT_DIR}/requirements.txt
210
211 # There are used three iterations of tests there to check
212 # the stability and reliability of the results
213
214 RC=0
215 MORE_FAILS=0
216
217 partial_logs=""
218 for test_set in 1 2 3
219 do
220     echo
221     echo ${test_set}. test loop
222     PYTHONPATH=`pwd` pybot -L TRACE -W 136\
223         -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology.yaml \
224         --suite "tests.vpp.func" \
225         --include vm_envAND3_node_single_link_topo \
226         --include vm_envAND3_node_double_link_topo \
227         --exclude PERFTEST \
228         --exclude SOFTWIRE \
229         --noncritical EXPECTED_FAILING \
230         --output ${LOG_PATH}/output_test_set${test_set} \
231         tests/
232     PARTIAL_RC=$(echo $?)
233     partial_logs="${partial_logs} ${LOG_PATH}/output_test_set${test_set}.xml"
234     if [ ${PARTIAL_RC} -eq 250 ]; then
235         MORE_FAILS=1
236     fi
237     RC=$((RC+PARTIAL_RC))
238 done
239
240 # Log the final result
241 if [ ${RC} -eq 0 ]; then
242     set +x
243     echo
244     echo "========================================================================================================================================"
245     echo "Final result of all test loops:                                                                                                 | PASS |"
246     echo "All critical tests have passed."
247     echo "========================================================================================================================================"
248     echo
249     set -x
250 elif [ ${MORE_FAILS} -eq 0 ]; then
251     if [ ${RC} -eq 1 ]; then
252         HLP_STR="test has"
253     else
254         HLP_STR="tests have"
255     fi
256     set +x
257     echo
258     echo "========================================================================================================================================"
259     echo "Final result of all test loops:                                                                                                 | FAIL |"
260     echo "${RC} critical ${HLP_STR} failed."
261     echo "========================================================================================================================================"
262     echo
263     set -x
264 else
265     set +x
266     echo
267     echo "========================================================================================================================================"
268     echo "Final result of all test loops:                                                                                                 | FAIL |"
269     echo "More then 250 critical tests have failed in one test loop."
270     echo "========================================================================================================================================"
271     echo
272     set -x
273 fi
274
275 echo Post-processing test data...
276
277 # Rebot output post-processing
278 rebot --noncritical EXPECTED_FAILING \
279       --output output.xml ${partial_logs}
280
281 # Remove unnecessary log files
282 rm -f ${partial_logs}
283
284 echo Post-processing finished.
285
286 if [ ${RC} -eq 0 ]; then
287     RETURN_STATUS=0
288 else
289     RETURN_STATUS=1
290 fi
291
292 exit ${RETURN_STATUS}

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.